@use '~@angular/material' as mat;

$transition:      .3s;

$primary-light:   #5E0A93;
$secondary-light: #57048A;
$tertiary-light:  #704F8F;
$focus-light:     #6609A4;
$site-bg-light:   #D9D9D9;
$text-light:      #1C1C1C;
$code-bg-light:   #B9B9B9;
$text-area-bg-light: #B9B9B9;

$primary-dark:    #380556;
$secondary-dark:  #230136;
$tertiary-dark:   #614C78;
$focus-dark:      #5A0793;
$site-bg-dark:    #161420;
$text-dark:       #D5D5D5;
$code-bg-dark:      #1C1C1C;
$text-area-bg-dark: #1C1C1C;

$splash-bg:       #113243;
$splash-lines:    #1B0341;

$header-height:       3rem;
$header-bg:           var(--primary);
$header-transition:   .4s;

$footer-height:       1rem;
$footer-bg:           var(--secondary);

$primary-palette:     (
                        50 : #E7E1EB,
                        100 : #C3B4CC,
                        200 : #9C82AB,
                        300 : #745089,
                        400 : #562B6F,
                        500 : #380556,
                        600 : #32044F,
                        700 : #2B0445,
                        800 : #24033C,
                        900 : #17012B,
                        A100 : #A565FF,
                        A200 : #8732FF,
                        A400 : #6900FE,
                        A700 : #5F00E5,
                        contrast: (
                          50 : #000000,
                          100 : #000000,
                          200 : #000000,
                          300 : #FFFFFF,
                          400 : #FFFFFF,
                          500 : #FFFFFF,
                          600 : #FFFFFF,
                          700 : #FFFFFF,
                          800 : #FFFFFF,
                          900 : #FFFFFF,
                          A100 : #000000,
                          A200 : #FFFFFF,
                          A400 : #FFFFFF,
                          A700 : #FFFFFF,
                        )
                      );

$secondary-palette:   (
                        50 : #E5E1E7,
                        100 : #BDB3C3,
                        200 : #91809B,
                        300 : #654D72,
                        400 : #442754,
                        500 : #230136,
                        600 : #1F0130,
                        700 : #1A0129,
                        800 : #150122,
                        900 : #0C0016,
                        A100 : #9356FF,
                        A200 : #7323FF,
                        A400 : #5700EF,
                        A700 : #4E00D5,
                        contrast: (
                          50 : #000000,
                          100 : #000000,
                          200 : #000000,
                          300 : #FFFFFF,
                          400 : #FFFFFF,
                          500 : #FFFFFF,
                          600 : #FFFFFF,
                          700 : #FFFFFF,
                          800 : #FFFFFF,
                          900 : #FFFFFF,
                          A100 : #FFFFFF,
                          A200 : #FFFFFF,
                          A400 : #FFFFFF,
                          A700 : #FFFFFF,
                        )
                      );

$warn-palette:        (
                        50 : #F0E1E6,
                        100 : #D9B4C1,
                        200 : #C08298,
                        300 : #A6506E,
                        400 : #932B4F,
                        500 : #800530,
                        600 : #78042B,
                        700 : #6D0424,
                        800 : #63031E,
                        900 : #500113,
                        A100 : #FF8394,
                        A200 : #FF5068,
                        A400 : #FF1D3D,
                        A700 : #FF0327,
                        contrast: (
                          50 : #000000,
                          100 : #000000,
                          200 : #000000,
                          300 : #FFFFFF,
                          400 : #FFFFFF,
                          500 : #FFFFFF,
                          600 : #FFFFFF,
                          700 : #FFFFFF,
                          800 : #FFFFFF,
                          900 : #FFFFFF,
                          A100 : #000000,
                          A200 : #000000,
                          A400 : #FFFFFF,
                          A700 : #FFFFFF,
                        )
                      );

$mat-primary-palette: mat.define-palette($primary-palette);
$mat-accent-palette:  mat.define-palette($secondary-palette);
$mat-warn-palette:    mat.define-palette($warn-palette);

$mat-theme:           mat.define-light-theme((
  color: (
    primary: $mat-primary-palette,
    accent: $mat-accent-palette,
    warn: $mat-warn-palette,
  )
));

@import 'tailwindcss/base';
@import 'tailwindcss/components';
@import 'tailwindcss/utilities';

@include mat.core();
@include mat.all-component-themes($mat-theme);
.material-icons {
  font-family: "Material Icons Outlined", "Material Icons", "serif";
}

@layer base {
  :root {
    --primary:       #{$primary-light};
    --secondary:     #{$secondary-light};
    --tertiary:      #{$tertiary-light};
    --focus:         #{$focus-light};
    --site-bg:       #{$site-bg-light};
    --text:          #{$text-light};
    --code-bg:       #{$code-bg-light};
    --text-area-bg:  #{$text-area-bg-light};

    --header-height: #{$header-height};
    --header-bg:     #{$header-bg};
    --footer-height: #{$footer-height};
    --footer-bg:     #{$footer-bg};
    --transition:    #{$transition};
  }
  @media (prefers-color-scheme: dark) {
    :root {
      --primary:       #{$primary-dark};
      --secondary:     #{$secondary-dark};
      --tertiary:      #{$tertiary-dark};
      --focus:         #{$focus-dark};
      --site-bg:       #{$site-bg-dark};
      --text:          #{$text-dark};
      --code-bg:       #{$code-bg-dark};
      --text-area-bg:  #{$text-area-bg-dark};
    }
  }

  html, body, demo-root {
    display:    block;
    min-height: 100vh;
  }

  body {
    background: var(--site-bg);
    color:      var(--text);
    font-size:  14px;
    @screen sm {
      font-size: 16px;
    }
  }

  header, footer {
    z-index:    1;
    position:   fixed;
    left:       0;
    right:      0;
    display:    flex;
    color: white;
  }

  header {
    top:        0;
    background: var(--header-bg);
    height:     var(--header-height);
    box-shadow: inset 0 0 4px black, 0 0 3px var(--secondary);
  }

  footer {
    bottom:     0;
    background: var(--footer-bg);
    height:     var(--footer-height);
    box-shadow: inset 0 0 4px black, 0 0 3px #13001A;
    font-size: 10px;
    justify-content: center;
    align-items: center;
  }

  demo-root {
    padding-top:         var(--header-height);
    padding-bottom:      var(--footer-height);
    transition-property: padding, opacity;
    transition-duration: var(--transition);
  }

  router-outlet + * {
    display:  block;
    position: relative;
  }

  h1 {
    @apply text-2xl;
  }

  h2 {
    @apply text-xl;
  }

  a {
    color: var(--tertiary);
  }

  code {
    display: inline-block;
    color:   var(--focus);
  }

  pre > code {
    display:          block;
    color: var(--text);
    background-color: var(--code-bg);
    padding:          .5rem;
    border-radius:    .5rem;
    border:           1px solid var(--primary);
    overflow: auto;
    white-space: pre;
  }

  textarea {
    background-color: var(--text-area-bg);
    padding: .5rem;
  }
}

@keyframes slide-in {
  100% { transform: translate(0, 0) }
}
